import 'd3-selection-multi';
import { Mark } from './Mark';
export declare abstract class ScatterBase extends Mark {
    render(): Promise<void>;
    set_ranges(): void;
    set_positional_scales(): void;
    initialize_additional_scales(): void;
    create_listeners(): void;
    get_element_color(data: any, index: any): any;
    get_element_size(data: any): any;
    get_element_opacity(data: any, index: any): any;
    get_element_skew(data: any): any;
    get_element_rotation(d: any): string;
    relayout(): void;
    update_position(animate?: any): void;
    draw(animate?: any): void;
    draw_elements(animate: any, elements_added: any): void;
    process_click(interaction: any): void;
    reset_hover_points(): void;
    scatter_hover_handler(args: any): void;
    reset_selection(): void;
    scatter_click_handler(args: any): void;
    hovered_style_updated(model: any, style: any): void;
    unhovered_style_updated(model: any, style: any): void;
    draw_legend(elem: any, x_disp: any, y_disp: any, inter_x_disp: any, inter_y_disp: any): number[];
    draw_legend_elements(elements_added: any, rect_dim: any): void;
    invert_point(pixel: any): void;
    selector_changed(point_selector: any, rect_selector: any): any[];
    update_selected(model: any, value: any): void;
    update_hovered(model: any, value: any): void;
    apply_styles(style_arr?: any): void;
    clear_style(style_dict: any, indices: any): void;
    set_style_on_elements(style: any, indices: any): void;
    compute_view_padding(): void;
    update_array(d: any, i: any): void;
    set_drag_behavior(): void;
    set_drag_style(d: any, i: any, dragged_node: any): void;
    reset_drag_style(d: any, i: any, dragged_node: any): void;
    drag_start(d: any, i: any, dragged_node: any): void;
    on_drag(d: any, i: any, dragged_node: any): void;
    drag_ended(d: any, i: any, dragged_node: any): void;
    selected_deleter(): void;
    add_element(): void;
    delete_element(args: any): void;
    abstract color_scale_updated(animate?: any): any;
    abstract update_default_opacities(animate?: any): any;
    abstract update_default_skew(animate?: any): any;
    abstract update_default_size(animate?: any): any;
    hovered_index: any;
    hovered_style: any;
    unhovered_style: any;
    drag_listener: any;
    pixel_coords: any;
    legend_el: any;
    x_pixels: any;
    y_pixels: any;
    x_scale: any;
    y_scale: any;
}
